class Artikel:
    '''Verwaltet Artikel für einen Laden/Webshop'''

    liste = [] # Sammlung aller Artikel-Objekte

    def uebersicht():
        '''Gibt den Zustand aller Objekte auf der Shell aus'''
        for a in Artikel.liste:
            print(a) # ruft automatisch __str__(self) mit a=self auf  
    
    def __init__(self, name, einkaufspreis, verkaufspreis):
        self.name = name
        self.ep = einkaufspreis
        self.vp = verkaufspreis
        self.bestand = 0
        self.erfolg = 0
        Artikel.liste.append(self)

    def __str__(self):
        '''Gibt eine Textdarstellung des Artikels zurück'''
        txt  = 'Artikel: {0}\n'.format(self.name)
        txt += 'Lagerbestand: {0}\n'.format(self.bestand)
        txt += 'Einkaufspreis: {0}\n'.format(self.ep)
        txt += 'Verkaufspreis: {0}\n'.format(self.vp)
        txt += 'Erfolg: {0}\n'.format(self.erfolg)
        return txt

    def set_einkaufspreis(self, neuer_preis):
        '''Einkaufspreis des Artikels ändern'''
        self.ep = neuer_preis

    def set_verkaufspreis(self, neuer_preis):
        '''Verkaufspreis eines Artikels ändern'''
        self.vp = neuer_preis

    def einkauf(self, anzahl):
        '''Einkauf von anzahl Artikeln zum Einkaufspreis'''
        self.bestand += anzahl
        self.erfolg -= anzahl*self.ep

    def verkauf(self, anzahl):
        '''Verkauf von anzahl Artikeln zum Verkaufspreis'''
        if anzahl > self.bestand:
            print('Nicht genügend Artikel an Lager!')
            return None
        self.bestand -= anzahl
        self.erfolg += anzahl*self.vp
        
        
